#pragma once

#ifdef __cplusplus
extern "C" {
#endif

#include <inttypes.h>

#define TASK_COUNT 7
#define CHANNEL_COUNT 7

extern const uint32_t TASK_CONNECTIONS[ TASK_COUNT ];

typedef struct {
    const uint32_t * bindings;
    uint32_t tasks[ TASK_COUNT ];
    uint32_t channels[ CHANNEL_COUNT ];
} SignalProcessing;

void signal_processing_init( SignalProcessing * system, const uint32_t * bindings );
void signal_processing_run( SignalProcessing * system );
void signal_processing_print_results( SignalProcessing * system );

#ifdef __cplusplus
}
#endif

